#include <iostream>
#include <string>
#include <vector>
using namespace std;

int GATE;
int INIT_SIGN;

void printGate(int G)
{
	for(int a=0;a<3;++a)
	for(int b=0;b<3;++b)
	{
		int z = a*3+b;
		int g = G;
		while( z --> 0 )
			g /= 9;
		int v = g%9;
		int c = v/3;
		int d = v%3;
		cout << "[" << a << b << " -> " << c << d << "]" << endl;
	}
}

void gate(int a, int b, int* c, int *d)
{
	int z = a*3+b;
	int g = GATE;
	while( z --> 0 )
		g /= 9;
	int v = g%9;
	*c = v/3;
	*d = v%3;
}


string L = "02120112100002120"; // X me # X me
string R = "22022022022022022"; // me X # me X
string Q = "22120221022022120"; // X me # me X
string P = "01210221200001210"; // me X # X me
static const int N = 17;
vector<int> xL(N), yL(N), xR(N), yR(N), IN(N), xQ(N), yQ(N), xP(N), yP(N);


void rec(int i)
{
	if( i == N ) {
		cout << GATE << endl;
		printGate(GATE);
		for(int k=0; k<i; ++k)
			cout << " " << IN[k];
		cout << endl;
		return;
	}

	for(IN[i]=0; IN[i]<3; ++IN[i])
	{
		gate(IN[i], i==0 ? INIT_SIGN : yL[i-1], &xL[i], &yL[i]);
		if(xL[i]!=L[i]-'0') continue;

		gate(i==0 ? INIT_SIGN : xR[i-1], IN[i], &xR[i], &yR[i]);
		if(yR[i]!=R[i]-'0') continue;

		gate(IN[i], i==0 ? INIT_SIGN : xQ[i-1], &xQ[i], &yQ[i]);
		if(yQ[i]!=Q[i]-'0') continue;

		gate(i==0 ? INIT_SIGN : yP[i-1], IN[i], &xP[i], &yP[i]);
		if(xP[i]!=P[i]-'0') continue;

		rec(i+1);
	}
}

int main()
{
	for(INIT_SIGN=0; INIT_SIGN<3; ++INIT_SIGN)
		for(GATE=0; GATE<(9*9*9)*(9*9*9)*(9*9*9); ++GATE)
			rec(0);
}

