#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <string>
using namespace std;

int GATE = 23800871;
void gate(int a, int b, int* c, int *d)
{
	*c = (a+3-b)%3;
	*d = (a*b+2)%3;
	return;
	int z = a*3+b;
	int g = GATE;
	while( z --> 0 )
		g /= 9;
	int v = g%9;
	*c = v/3;
	*d = v%3;
}


static const int BUFS = 9999999;
char buf[BUFS], *p;

// X=-1, L=false, R=true
typedef pair<int,bool> PORT;
PORT parse_port()
{
	if( *p == 'X' )
		{++p; return make_pair(-1, false);}
	int v = 0;
	while('0'<=*p && *p<='9')
		v = v*10 + (*p++ - '0');
	return make_pair(v, *p++ == 'R');
}

map<int, PORT> il;
map<int, PORT> ir;
map<int, PORT> ol;
map<int, PORT> or;
map<int, int> status_ol;
map<int, int> status_or;

int main(int argc, const char* argv[])
{
	if(argc<=1)
		{cerr<<"give me filename"<<endl; return -1;}
	fstream fin(argv[1]);
	if(!fin)
		{cerr<<"cannot open file"<<endl; return -1;}
	fin.read(buf, BUFS);
	p = buf;

	pair<int, bool> XI = parse_port();
	++p; // ':'
	while(*p=='\r' || *p=='\n') ++p; // \r\n
	int G=0;
	for(G=0 ;; ++G) {
		PORT IL = parse_port();
		il[G] = IL;
		PORT IR = parse_port();
		ir[G] = IR;
		++p; ++p; // 0#
		PORT OL = parse_port();
		ol[G] = OL;
		PORT OR = parse_port();
		or[G] = OR;
		if( *p==':' )
			break;
		++p; //','
		while(*p=='\r' || *p=='\n') ++p; // \r\n
	}
	++p; // :
	while(*p=='\r' || *p=='\n') ++p; // \r\n
	pair<int, bool> XO = parse_port();


//	string INPUT = "02222220210110011"; // task input for obtaining key
	string INPUT = "01202101210201202"; // server input 
//	string INPUT = "00000000000000000";
//	string INPUT = "11111111111111111";
//	while( cout<<"? ", getline(cin, INPUT) )
	{
//PRE 11010110101110122
//PRE 21001222122120011
//INP 02222220210110011
//KEY 11021210112101221
		for(int g=-1; g<=G; ++g)
			status_ol[g] = status_or[g] = 0;
		for(int i=0; i<INPUT.size(); ++i)
		{
			status_ol[-1] = INPUT[i] - '0';
			for(int g=0; g<=G; ++g)
			{
				int inl = (il[g].second ? status_or : status_ol)[il[g].first];
				int inr = (ir[g].second ? status_or : status_ol)[ir[g].first];
				int oul, our;
				gate(inl, inr, &oul, &our);
				status_ol[g] = oul;
				status_or[g] = our;
			}
			cout << (XO.second ? status_or : status_ol)[XO.first];
//			for(int g=0; g<=G; ++g)
//				cout << g << " : " << status_ol[g] << " " << status_or[g] << endl;
//			cout << "[" << (XO.second ? status_or : status_ol)[XO.first] << "]" << endl;;
		}
		cout << endl;
	}
}
